#!/usr/bin/perl -w

use strict;
use warnings;

my $inFile    = "infile.fas";
my $outFirst  = "1st.fas";
my $outSecond = "2nd.fas";
my $outThird  = "3rd.fas";


open(IN,"$inFile") or die "Cannot find $inFile\n";
my @inFileCont = <IN>;
close IN;

my $refRec = &fasReader2d(\@inFileCont);
my @recs    = @$refRec;

open(FIRST,">$outFirst");
foreach my $ele (@recs) {
  print FIRST "$ele->[0]\n";
  my @tempSeq = @{$ele->[1]};
  for(my $i=0; $i<scalar(@tempSeq); $i++){
    print FIRST "$tempSeq[$i]" if $i % 3 == 0;
  }
  print FIRST "\n";
}
close FIRST;

open(SECOND,">$outSecond");
foreach my $ele (@recs) {
  print SECOND "$ele->[0]\n";
  my @tempSeq = @{$ele->[1]};
  for(my $i=0; $i<scalar(@tempSeq); $i++){
    print SECOND "$tempSeq[$i]" if $i % 3 == 1;
  }
  print SECOND "\n";
}
close SECOND;

open(THIRD,">$outThird");
foreach my $ele (@recs) {
  print THIRD "$ele->[0]\n";
  my @tempSeq = @{$ele->[1]};
  for(my $i=0; $i<scalar(@tempSeq); $i++){
    print THIRD "$tempSeq[$i]" if $i % 3 == 2;
  }
  print THIRD "\n";
}
close THIRD;


exit;

sub fasReader2d{

  my $uniqNameSR = "";
  my $flag = 0;

  my @recs2D = ();
  my @tempSeq = ();
  my $tempSeq = "";

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine =~ /^>/){  
      if($flag == 0){
        $uniqNameSR = $inFileLine;
        $flag = 1;  
      } else {
        my @tempSeqArray = split(//, $tempSeq);
        push(@recs2D, [$uniqNameSR, \@tempSeqArray]);
        $uniqNameSR = $inFileLine;
        $tempSeq = "";
      }
    } else {
      $tempSeq .= $inFileLine;
    }
  }
  my @tempSeqArray = split(//, $tempSeq);
  push(@recs2D, [$uniqNameSR, \@tempSeqArray]);

  return (\@recs2D);
}